#!/usr/bin/env python
# usage: rotagator.py sigfile tmpsigfile
# Note sigfile is in fortune file format (%\n between each signature)
"""
rotagator.py
Copyright © 2003 by Padraig Brady <P@draigBrady.com>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
"""
import sys
import os
import random
try:
    sig=sys.argv[1]
    base=file(sig+'.base').read()
except:
    print "error reading base file"
    sys.exit(1)
try:
    sigs=file(sig+'.sigs').read().split('%\n')
except:
    print "error reading signatures file"
    sys.exit(1)
tmp=sig+'.tmp'

osrelease=file('/proc/sys/kernel/osrelease').read()[:-1]
sig_data=base.replace('%osrelease',"linux-%s" % osrelease)

uptime_sec=int(file('/proc/uptime').readline().split()[0].split('.')[0])
uptime="%02dd %02dh %02dm" % (uptime_sec/86400,(uptime_sec%86400)/3600,(uptime_sec%3600)/60)
sig_data=sig_data.replace('%uptime',"uptime %s" % uptime)

sig_file=random.choice(sigs).strip()
sig_data=sig_data.replace('%sig',sig_file)
file(tmp,'w').write(sig_data)
os.rename(tmp,sig)
